﻿using System;
using System.Configuration;
using System.Data;
using System.Data.Sql;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using SIP;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Net;
using System.IO;
using System.Xml;
using System.Xml.XPath;
using System.Security.Principal;
using System.DirectoryServices;
using System.Collections.Specialized;


public partial class BuscaSIP : System.Web.UI.Page
{

    public bool IsAuthenticated(string srvr, string usr, string pwd)
    {
        //srvr = ldap server, e.g. LDAP://domain.com
        //usr = user name
        //pwd = user password
        bool authenticated = false;

        try
        {
            DirectoryEntry entry = new DirectoryEntry(srvr, usr, pwd);
            object nativeObject = entry.NativeObject;
            authenticated = true;
        }
        catch (DirectoryServicesCOMException cex)
        {
            //not authenticated; reason why is in cex
        }
        catch (Exception ex)
        {
            //not authenticated due to some other exception [this is optional]
        }
        return authenticated;
    }



    protected void Page_Load(object sender, EventArgs e)
    // Al cargar la página
    {
        // Damos título a la página
        this.Title = "Búsqueda en SIP";


        // Obtenemos la dirección IP de la consulta al servicio web
        string ip = this.Context.Request.UserHostAddress;

        // Recuperamos el login y el password
        if (!IsPostBack)
        {
            lblUser.Text = Context.Items["user"].ToString();
            lblPass.Text = Context.Items["pass"].ToString();
        }

        // Variables para la conexión al Active Directory
        string dominio = @"LDAP://baladre";
        string user = lblUser.Text;
        string pass = lblPass.Text;

        /////// Compruebo en el Active Directory si el usuario está autorizado a utilizar la aplicación
        try
        {
            if (IsAuthenticated(@"LDAP://baladre", user, pass) == true)
            {
                /////// Solicitamos al Active Directory información del usuario logueado
                AuthenticationTypes at = AuthenticationTypes.Anonymous;
                at = AuthenticationTypes.Secure;

                DirectoryEntry entryRoot = new DirectoryEntry(@"LDAP://baladre", user, pass, at);

                DirectorySearcher ds = new DirectorySearcher(entryRoot);

                ds.Filter = "samaccountname=" + user;

                /////// Obtengo del Active Directory los grupos a los que pertenece el usuario logueado
                ds.PropertiesToLoad.Add("memberof");

                SearchResult sr = ds.FindOne();

                System.Text.StringBuilder sb = new System.Text.StringBuilder();

                bool BuscaTriada = false;

                foreach (string var in sr.Properties.PropertyNames)
                {
                    for (int i = 0; i < sr.Properties[var].Count; i++)
                        if (sr.Properties[var][i].ToString().Contains("CN=BuscaSip"))
                        {
                            BuscaTriada = true;
                        }
                }

                if (BuscaTriada == false)
                {
                    ///// Guardamos en 'BuscaSip_Log.txt' la consulta
                    // Especificamos la ruta de 'BuscaSip_Log.txt'
                    const string fic = @"C:\Inetpub\wwwroot\PruebasSip\Logs\BuscaSip_Log.txt";
                    // Creamos la cadena a escribir
                    string texto = string.Empty;

                    texto = "[" + DateTime.Now.ToString() + "]";
                    texto += " >>> NO PERTENECE AL GRUPO 'BUSCASIP' <<<";
                    texto += " IP request: " + ip;
                    texto += " User: " + user;
                    // Añadimos a 'BuscaSip_Log.txt' la nueva cadena
                    System.IO.StreamWriter sw = new System.IO.StreamWriter(fic, true, System.Text.Encoding.Default);
                    sw.WriteLine(texto.ToUpper());
                    sw.Close();
                    Response.Redirect("~/Denied.aspx");
                    return;
                }

                /////// Obtengo del Active Directory el nombre del usuario logueado
                ds.PropertiesToLoad.Remove("memberof");
                ds.PropertiesToLoad.Add("displayname");

                sr = ds.FindOne();

                sb = new System.Text.StringBuilder();

                foreach (string var in sr.Properties.PropertyNames)
                {
                    for (int i = 0; i < sr.Properties[var].Count; i++)
                    {
                        lblLogueado.Text = sr.Properties[var][i].ToString();
                    }
                }
            }
            else
            {
                ///// Guardamos en 'BuscaSip_Log.txt' la consulta
                // Especificamos la ruta de 'BuscaSip_Log.txt'
                const string fic = @"C:\Inetpub\wwwroot\PruebasSip\Logs\BuscaSip_Log.txt";
                // Creamos la cadena a escribir
                string texto = string.Empty;

                texto = "[" + DateTime.Now.ToString() + "]";
                texto += " >>> NO AUTENTIFICADO <<<";
                texto += " IP request: " + ip;
                texto += " User: " + user;
                // Añadimos a 'BuscaSip_Log.txt' la nueva cadena
                System.IO.StreamWriter sw = new System.IO.StreamWriter(fic, true, System.Text.Encoding.Default);
                sw.WriteLine(texto.ToUpper());
                sw.Close();
                Response.Redirect("~/Denied.aspx");
                return;
            }
        }
        catch (Exception ex)     // Si devuelve algún error
        {
            Response.Redirect("~/Denied.aspx");
            return;
        }


        /////////


        string respuesta = string.Empty;

        /////////

        if (!IsPostBack)
        {
            // Ponemos el foco en la casilla del SIP
            SetFocus(txtSip2);
        }

        //lblAviso.Text = HttpContext.Current.Request.LogonUserIdentity.Name.ToString();
        //lblAviso.Text = HttpContext.Current.Request.LogonUserIdentity.Name.ToString();
        
    }
    
    protected void Button1_Click(object sender, EventArgs e)
    // Al pulsar sobre el botón
    {
        string user = lblUser.Text;
        string pass = lblPass.Text;

        if (txtSip2.Text.Length == 0)
        // Si no hemos introducido ningún número SIP
        {
            // Avisamos al usuario de que no se ha introducido ningún número SIP
            lblAviso.Text = "Ningún criterio de búsqueda ha sido especificado.";
            // Salimos
            return;
        }
        
        ///// Guardamos en 'BuscaSip_Log.txt' la consulta
        // Especificamos la ruta de 'BuscaSip_Log.txt'
        const string fic = @"C:\Inetpub\wwwroot\PruebasSip\Logs\BuscaSip_Log.txt";
        // Obtenemos la dirección IP del cliente
        string ip = HttpContext.Current.Request.UserHostAddress.ToString();
        // Creamos la cadena a escribir
        string texto = string.Empty;

        texto = "[" + DateTime.Now.ToString() + "]";
        texto += " IP request: " + ip;
        texto += " User: " + user;
        texto += " -> " + "SIP=" + txtSip2.Text;
        // Añadimos a 'BuscaSip_Log.txt' la nueva cadena
        System.IO.StreamWriter sw = new System.IO.StreamWriter(fic, true, System.Text.Encoding.Default);
        sw.WriteLine(texto.ToUpper());
        sw.Close();
        
        // Llamamos al Servicio Web
        dtvceres.BuscaSIPwebservice wsBuscaSIP = new dtvceres.BuscaSIPwebservice();

        // Almacenamos en una variable el Número de SIP
        string sip = txtSip2.Text;

        // Vaciamos la cadena 'respuesta'
        string respuesta = string.Empty;


        // Preguntamos a la Base de Datos del SIP por ése Número de SIP en concreto
        
        try     // Si no devuelve ningún error
        {
            // Llamamos a la función que consulta en la base de datos del SIP
            // pasándole el número de SIP y el usuario que realiza la consulta
            respuesta = wsBuscaSIP.busca_SIP(sip, user, pass);

            if (respuesta == "<respuesta>USTED NO TIENE PERMISO PARA CONSULTAR ESTA BASE DE DATOS.</respuesta>")
            {
                lblAviso.Text = "USTED NO TIENE PERMISO PARA CONSULTAR ESTA BASE DE DATOS.";
                return;
            }

            // Convertimos la cadena recibida en un XPathDocment para poder recorrerlo
            StringReader rdr = new StringReader(respuesta);
            XPathDocument resp_xpath = new XPathDocument(rdr);

            // Almacenamos en el contexto tanto la cadena como el Xpath
            Context.Items.Add("resp", resp_xpath);
            Context.Items.Add("cadenaxml", respuesta);

            // Llamamos a la página donde se muestra el resultado formateado
            Server.Transfer("Resultado.aspx", false);  
        }
        catch(Exception ex)     // Si devuelve algún error
        {
            // Mostramos el aviso de error en lblAviso
            lblAviso.Text = "Número de SIP no encontrado.<br>Esto puede deberse a un fallo en la conexión o a que el número de SIP no existe en la base de datos.";

            // Terminamos la ejecución
            return;
        }

    }

    protected void txtSip2_TextChanged(object sender, EventArgs e)
    {
        Button1_Click(this, null);
    }
}
