﻿<%@ WebService Language="C#" Class="BuscaSIPwebservice" %>

	using System;
	using System.Collections;
	using System.ComponentModel;
    using System.Data;
    using System.Data.Sql;
    using System.Data.SqlClient;
	using System.Web;
	using System.Web.Services;
	using System.Web.Services.Protocols;
	using System.Xml;
	using System.Xml.XPath;
	using System.Text;
	using System.Net;
	using System.IO;
    using System.Security.Principal;
    using System.DirectoryServices;
    using System.Collections.Specialized;

    //static string user = Request.ServerVariables["REMOTE_HOST"];

[WebService(Namespace = "BuscaSIP", Description = "Funciones utilizadas para la búsqueda en SIP.")]
public class BuscaSIPwebservice : System.Web.Services.WebService
{
    public bool IsAuthenticated(string srvr, string usr, string pwd)
    {
        //srvr = ldap server, e.g. LDAP://domain.com
        //usr = user name
        //pwd = user password
        bool authenticated = false;

        try
        {
            DirectoryEntry entry = new DirectoryEntry(srvr, usr, pwd);
            object nativeObject = entry.NativeObject;
            authenticated = true;
        }
        catch (DirectoryServicesCOMException cex)
        {
            //not authenticated; reason why is in cex
        }
        catch (Exception ex)
        {
            //not authenticated due to some other exception [this is optional]
        }
        return authenticated;
    }
    
    //string user = HttpContext.Current.Request.ServerVariables["HTTP_CLIENT-IP"];
    ////// Funciones para Búsqueda en SIP
    [WebMethod(Description = "Crea la petición XML a enviar a partir del " +
                             "número de SIP que queremos consultar.")]
    // Crea la petición XML a enviar a partir
    // del número de SIP que queremos consultar
    protected string peticionXML(string nsip)
    {
        // Creamos la variable que contendrá la petición
        string cString;

        // Completamos la cadena con la variable 'nsip'
        cString = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>"
        + "<mensaje_peticion xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"
            + "<msg_cab>"
                + "<conexion>"
                    + "<aplicacion>INTAI</aplicacion>"
                    + "<centro>99999</centro>"
                    + "<IP>0.0.0.0</IP>"
                    + "<msg_num>String</msg_num>"
                    + "<msg_dat>2001-09-11T09:30:47</msg_dat>"
                    + "<usuario>"
                        + "<usua_key>INTAI</usua_key>"
                        + "<usua_nom>String</usua_nom>"
                        + "<usua_ape1>String</usua_ape1>"
                        + "<usua_ape2>String</usua_ape2>"
                        + "<usua_centro>99999</usua_centro>"
                        + "<usua_centro_descripcion>String</usua_centro_descripcion>"
                    + "</usuario>"
                + "</conexion>"
                + "<servicio>"
                    + "<nombre>ubu_nsip</nombre>"
                + "</servicio>"
            + "</msg_cab>"
            + "<cuerpo>"
                + "<retorno>"
                    + "<nombre>funcioneval</nombre>"
                + "</retorno>"
                + "<nsip>" + nsip + "</nsip>"   // Aquí introducimos el número de SIP solicitado
                // Bloques de información a solicitar
                + "<bloque>IDEN</bloque>"
                + "<bloque>LOCA</bloque>"
                + "<bloque>ACRE</bloque>"
                + "<bloque>ASIG</bloque>"
                + "<bloque>TARJ</bloque>"
                + "<bloque>EXPE</bloque>"
                + "<bloque>BAJA</bloque>"
                + "<bloque>MISC</bloque>"
                + "<bloque>INCI</bloque>"
                // Fin de los bloques de información a solicitar
            + "</cuerpo>"
        + "</mensaje_peticion>";

        // Devolvemos la cadena con la petición XML completa
        return cString;
    }

    [WebMethod(Description = "Conecta con la base de datos del SIP y devuelve " +
                             "un documento XML con los datos solicitados.")]
    // Conecta con la base de datos del SIP y devuelve
    // un documento XML con los datos solicitados
    protected string TestPeticion(string peticion)
    {
        peticion = "pdi_xml=" + peticion;
        Encoding encoding = System.Text.Encoding.GetEncoding("iso-8859-1");
        Byte[] byteArray = encoding.GetBytes(peticion);

        HttpWebRequest request = (HttpWebRequest)WebRequest.Create("http://sip.san.gva.es/pls/tarjeta/wusu.directo_web");
        request.Credentials = CredentialCache.DefaultCredentials;
        request.Method = "POST";
        request.ContentLength = byteArray.Length;
        request.ContentType = "application/x-www-form-urlencoded";
        Stream dataStream = request.GetRequestStream();
        dataStream.Write(byteArray, 0, byteArray.Length);
        dataStream.Close();
        HttpWebResponse response = (HttpWebResponse)request.GetResponse();
        Stream receiveStream = response.GetResponseStream();
        StreamReader readStream = new StreamReader(receiveStream, encoding);
        XPathDocument xpath = new XPathDocument(readStream);

        return xpath.CreateNavigator().InnerXml;
    }
   
    [WebMethod(Description = "Función que dado un número de SIP, " +
                             "envía la petición en código XML " +
                             "para así recibir, también en código XML " +
                             "la respuesta por parte de " +
                             "la base de datos del SIP, " +
                             "incluyendo ésta toda la información " +
                             "solicitada en la petición.")]
    // Función que dado un número de SIP envía la petición en código XML para así
    // recibir, también en código XML la respuesta por parte de la base de datos
    // del SIP incluyendo ésta toda la información solicitada en la petición
    public string busca_SIP(string SIP, string usuario, string contrasenya)
    {
        // Obtenemos la dirección IP de la consulta al servicio web
        string ip = this.Context.Request.UserHostAddress;

        string respuesta = string.Empty;

        /////////////////////// SEGURIDAD ACTIVE DIRECTORY ///////////////////////

        string dominio = @"LDAP://baladre";
        string user = usuario;
        string pass = contrasenya;

        if ((user.Length < 1) || (pass.Length < 1))
        {
            respuesta = "<respuesta>FALTA ALGÚN PARÁMETRO.</respuesta>";

            // Convertimos la cadena en un XPathDocment
            StringReader rdr_Sec = new StringReader(respuesta);
            XPathDocument resp_xpath_Sec = new XPathDocument(rdr_Sec);

            // Mostramos el documento XML
            return resp_xpath_Sec.CreateNavigator().InnerXml;
        }

        /////// Compruebo en el Active Directory si el usuario está autorizado a utilizar la aplicación
        try
        {
            if (IsAuthenticated(@"LDAP://baladre", user, pass) == true)
            {
                /////// Solicitamos al Active Directory información del usuario logueado
                AuthenticationTypes at = AuthenticationTypes.Anonymous;
                at = AuthenticationTypes.Secure;

                DirectoryEntry entryRoot = new DirectoryEntry(@"LDAP://baladre", user, pass, at);

                DirectorySearcher ds = new DirectorySearcher(entryRoot);

                ds.Filter = "samaccountname=" + user;

                /////// Obtengo del Active Directory los grupos a los que pertenece el usuario logueado
                ds.PropertiesToLoad.Add("memberof");

                SearchResult sr = ds.FindOne();

                System.Text.StringBuilder sb = new System.Text.StringBuilder();

                bool BuscaSip = false;

                foreach (string var in sr.Properties.PropertyNames)
                {
                    for (int i = 0; i < sr.Properties[var].Count; i++)
                        if (sr.Properties[var][i].ToString().Contains("CN=BuscaSip"))
                        {
                            BuscaSip = true;
                        }
                }

                if (BuscaSip == false)
                {
                    ///// Guardamos en 'BuscaSip_Log.txt' la consulta
                    // Especificamos la ruta de 'BuscaSip_Log.txt'
                    const string fic2 = @"C:\Inetpub\wwwroot\PruebasSip\Logs\BuscaSipWS_Log.txt";
                    // Creamos la cadena a escribir
                    string texto2 = string.Empty;

                    texto2 = "[" + DateTime.Now.ToString() + "]";
                    texto2 += " >>> NO PERTENECE AL GRUPO 'BUSCASIP' <<<";
                    texto2 += " IP request: " + ip;
                    texto2 += " User: " + user;
                    // Añadimos a 'BuscaSip_Log.txt' la nueva cadena
                    System.IO.StreamWriter sw2 = new System.IO.StreamWriter(fic2, true, System.Text.Encoding.Default);
                    sw2.WriteLine(texto2.ToUpper());
                    sw2.Close();
                    // Si no está autentificado en el Active Directoy
                    respuesta = "<respuesta>USTED NO TIENE PERMISO PARA CONSULTAR ESTA BASE DE DATOS.</respuesta>";

                    // Convertimos la cadena en un XPathDocment
                    StringReader rdr_Sec = new StringReader(respuesta);
                    XPathDocument resp_xpath_Sec = new XPathDocument(rdr_Sec);

                    // Mostramos el documento XML
                    return resp_xpath_Sec.CreateNavigator().InnerXml;
                }
            }
            else
            {
                ///// Guardamos en 'BuscaSip_Log.txt' la consulta
                // Especificamos la ruta de 'BuscaSip_Log.txt'
                const string fic3 = @"C:\Inetpub\wwwroot\PruebasSip\Logs\BuscaSipWS_Log.txt";
                // Creamos la cadena a escribir
                string texto3 = string.Empty;

                texto3 = "[" + DateTime.Now.ToString() + "]";
                texto3 += " >>> NO AUTENTIFICADO <<<";
                texto3 += " IP request: " + ip;
                texto3 += " User: " + user;
                // Añadimos a 'BuscaSip_Log.txt' la nueva cadena
                System.IO.StreamWriter sw3 = new System.IO.StreamWriter(fic3, true, System.Text.Encoding.Default);
                sw3.WriteLine(texto3.ToUpper());
                sw3.Close();
                // Si no está autentificado en el Active Directoy
                respuesta = "<respuesta>USTED NO TIENE PERMISO PARA CONSULTAR ESTA BASE DE DATOS.</respuesta>";

                // Convertimos la cadena en un XPathDocment
                StringReader rdr_Sec = new StringReader(respuesta);
                XPathDocument resp_xpath_Sec = new XPathDocument(rdr_Sec);

                // Mostramos el documento XML
                return resp_xpath_Sec.CreateNavigator().InnerXml;
            }
        }
        catch (Exception ex)     // Si devuelve algún error
        {
            // Si no está autentificado en el Active Directoy
            respuesta = "<respuesta>USTED NO TIENE PERMISO PARA CONSULTAR ESTA BASE DE DATOS.</respuesta>";

            // Convertimos la cadena en un XPathDocment
            StringReader rdr_Sec = new StringReader(respuesta);
            XPathDocument resp_xpath_Sec = new XPathDocument(rdr_Sec);

            // Mostramos el documento XML
            return resp_xpath_Sec.CreateNavigator().InnerXml;
        }


        ///// Guardamos en 'Log.txt' la consulta
        // Especificamos la ruta de 'Log.txt'
        const string fic = @"C:\Inetpub\wwwroot\PruebasSip\Logs\BuscaSipWS_Log.txt";
        // Creamos la cadena a escribir
        string texto = string.Empty;

        texto = "[" + DateTime.Now.ToString() + "]";
        texto += " IP request: " + ip;
        texto += " User: " + usuario;
        texto += " -> " + "SIP=" + SIP;
        
        // Añadimos a 'Log.txt' la nueva cadena
        System.IO.StreamWriter sw = new System.IO.StreamWriter(fic, true, System.Text.Encoding.Default);
        sw.WriteLine(texto.ToUpper());
        sw.Close();
        

        
        // Creamos la petición en código XML a partir del número SIP dado
        string codigo_peticion = peticionXML(SIP);
        // Enviamos la petición XML y recibimos otro código XML con la respuesta
        // que nos envía la base de datos del SIP
        string respuestaXML = TestPeticion(codigo_peticion);

        
        
        
        // Devolvemos esta respuesta en código XML
        return respuestaXML;
    }
}