﻿<%@ WebService Language="C#" Class="BuscaTRIADAwebservice" %>

	using System;
    using System.Configuration;
    using System.Data;
    using System.Data.Sql;
    using System.Data.SqlClient;
    using System.Web;
    using System.Web.Security;
    using System.Web.UI;
    using System.Web.UI.HtmlControls;
    using System.Web.UI.WebControls;
    using System.Web.UI.WebControls.WebParts;
    using System.Xml.XPath;
    using System.IO;
    using System.Collections;
    using System.ComponentModel;
    using System.Web.Services;
    using System.Web.Services.Protocols;
    using System.Xml;
    using System.Text;
    using System.Net;
    using System.Security.Principal;
    using System.DirectoryServices;
    using System.Collections.Specialized;


[WebService(Namespace = "BuscaTRIADA", Description = "Funciones utilizadas para la búsqueda en TRIADA.")]
public class BuscaTRIADAwebservice : System.Web.Services.WebService
{

    [WebMethod(Description = "Obtiene la letra del NIF a partir de un DNI.")]
    // Obtiene la letra del NIF a partir de un DNI
    protected string letra_nif(UInt32 dni)
    {
        string s_letra = "TRWAGMYFPDXBNJZSQVHLCKE";
        dni = dni % 23;
        s_letra = s_letra[Convert.ToInt16(dni)].ToString();
        return s_letra;
    }

    public bool IsAuthenticated(string srvr, string usr, string pwd)
    {
        //srvr = ldap server, e.g. LDAP://domain.com
        //usr = user name
        //pwd = user password
        bool authenticated = false;

        try
        {
            DirectoryEntry entry = new DirectoryEntry(srvr, usr, pwd);
            object nativeObject = entry.NativeObject;
            authenticated = true;
        }
        catch (DirectoryServicesCOMException cex)
        {
            //not authenticated; reason why is in cex
        }
        catch (Exception ex)
        {
            //not authenticated due to some other exception [this is optional]
        }
        return authenticated;
    }


    [WebMethod(Description = "Función que devuelve un código XML con todas las " +
                             "coincidencias encontradas en TRIADA para los campos " +
                             "solicitados." + "</br>" + 
                             "(Para los apellidos se puede utilizar el símbolo '%' " + 
                             "como carácter comodín)")]
    // Función que devuelve un código XML con todas las
    // coincidencias encontradas en TRIADA para los campos solicitados    
    // (Para los apellidos se puede utilizar el símbolo '%' como carácter comodín)
    public string busca_TRIADA(string sip,
                               string dni,
                               string nombre,
                               string apellido1,
                               string apellido2,
                               string dia,
                               string mes,
                               string anyo,
                               string usuario,
                               string contrasenya)
    {

        // Obtenemos la dirección IP de la consulta al servicio web
        string ip = this.Context.Request.UserHostAddress;

        string respuesta = string.Empty;

        /////////////////////// SEGURIDAD ACTIVE DIRECTORY ///////////////////////

        string dominio = @"LDAP://baladre";
        string user = usuario;
        string pass = contrasenya;

        if ((user.Length < 1) || (pass.Length < 1))
        {
            respuesta = "<respuesta>FALTA ALGÚN PARÁMETRO.</respuesta>";

            // Convertimos la cadena en un XPathDocment
            StringReader rdr_Sec = new StringReader(respuesta);
            XPathDocument resp_xpath_Sec = new XPathDocument(rdr_Sec);

            // Mostramos el documento XML
            return resp_xpath_Sec.CreateNavigator().InnerXml;
        }

        /////// Compruebo en el Active Directory si el usuario está autorizado a utilizar la aplicación
        try
        {
            if (IsAuthenticated(@"LDAP://baladre", user, pass) == true)
            {
                /////// Solicitamos al Active Directory información del usuario logueado
                AuthenticationTypes at = AuthenticationTypes.Anonymous;
                at = AuthenticationTypes.Secure;

                DirectoryEntry entryRoot = new DirectoryEntry(@"LDAP://baladre", user, pass, at);

                DirectorySearcher ds = new DirectorySearcher(entryRoot);

                ds.Filter = "samaccountname=" + user;

                /////// Obtengo del Active Directory los grupos a los que pertenece el usuario logueado
                ds.PropertiesToLoad.Add("memberof");

                SearchResult sr = ds.FindOne();

                System.Text.StringBuilder sb = new System.Text.StringBuilder();

                bool BuscaTriada = false;

                foreach (string var in sr.Properties.PropertyNames)
                {
                    for (int i = 0; i < sr.Properties[var].Count; i++)
                        if (sr.Properties[var][i].ToString().Contains("CN=BuscaTriada"))
                        {
                            BuscaTriada = true;
                        }
                }

                if (BuscaTriada == false)
                {
                    ///// Guardamos en 'BuscaTriada_Log.txt' la consulta
                    // Especificamos la ruta de 'BuscaTriada_Log.txt'
                    const string fic = @"C:\Inetpub\wwwroot\PruebasSip\Logs\BuscaTriadaWS_Log.txt";
                    // Creamos la cadena a escribir
                    string texto = string.Empty;

                    texto = "[" + DateTime.Now.ToString() + "]";
                    texto += " >>> NO PERTENECE AL GRUPO 'BUSCATRIADA' <<<";
                    texto += " IP request: " + ip;
                    texto += " User: " + user;
                    texto.ToUpper();
                    // Añadimos a 'BuscaTriada_Log.txt' la nueva cadena
                    System.IO.StreamWriter sw = new System.IO.StreamWriter(fic, true, System.Text.Encoding.Default);
                    sw.WriteLine(texto.ToUpper());
                    sw.Close();
                    
                    // Si no está autentificado en el Active Directoy
                    respuesta = "<respuesta>USTED NO TIENE PERMISO PARA CONSULTAR ESTA BASE DE DATOS.</respuesta>";

                    // Convertimos la cadena en un XPathDocment
                    StringReader rdr_Sec = new StringReader(respuesta);
                    XPathDocument resp_xpath_Sec = new XPathDocument(rdr_Sec);

                    // Mostramos el documento XML
                    return resp_xpath_Sec.CreateNavigator().InnerXml;
                }
            }
            else
            {
                ///// Guardamos en 'BuscaTriada_Log.txt' la consulta
                // Especificamos la ruta de 'BuscaTriada_Log.txt'
                const string fic = @"C:\Inetpub\wwwroot\PruebasSip\Logs\BuscaTriadaWS_Log.txt";
                // Creamos la cadena a escribir
                string texto = string.Empty;

                texto = "[" + DateTime.Now.ToString() + "]";
                texto += " >>> NO AUTENTIFICADO <<<";
                texto += " IP request: " + ip;
                texto += " User: " + user;
                texto.ToUpper();
                // Añadimos a 'BuscaTriada_Log.txt' la nueva cadena
                System.IO.StreamWriter sw = new System.IO.StreamWriter(fic, true, System.Text.Encoding.Default);
                sw.WriteLine(texto.ToUpper());
                sw.Close();
                // Si no está autentificado en el Active Directoy
                respuesta = "<respuesta>USTED NO TIENE PERMISO PARA CONSULTAR ESTA BASE DE DATOS.</respuesta>";

                // Convertimos la cadena en un XPathDocment
                StringReader rdr_Sec = new StringReader(respuesta);
                XPathDocument resp_xpath_Sec = new XPathDocument(rdr_Sec);

                // Mostramos el documento XML
                return resp_xpath_Sec.CreateNavigator().InnerXml;
            }
        }
        catch (Exception ex)     // Si devuelve algún error
        {
            // Si no está autentificado en el Active Directoy
            respuesta = "<respuesta>USTED NO TIENE PERMISO PARA CONSULTAR ESTA BASE DE DATOS.</respuesta>";

            // Convertimos la cadena en un XPathDocment
            StringReader rdr_Sec = new StringReader(respuesta);
            XPathDocument resp_xpath_Sec = new XPathDocument(rdr_Sec);

            // Mostramos el documento XML
            return resp_xpath_Sec.CreateNavigator().InnerXml;
        }
        
        // Creamos un nuevo DataSet que englobe toda la respuesta
        DataSet MiDataSet = new DataSet("respuesta");
        // Creamos una nueva conexión a una Base de Datos en SQL
        SqlConnection conexion = new SqlConnection();
        string dataSource = string.Empty;
        string initialCatalog = string.Empty;
        string userId = string.Empty;
        string password = string.Empty;
        

        XmlTextReader reader = new XmlTextReader(@"C:\Inetpub\wwwroot\PruebasSip\Conexion\conexion.xml");
        XmlDocument document = new XmlDocument();
        document.Load(reader);
        XPathDocument doc = new XPathDocument(new XmlNodeReader(document));
        // Creamos el navegador que nos permitirá recorrer los nodos
        XPathNavigator navigator = doc.CreateNavigator();
        XPathNavigator node;
        
        ////// RECORREMOS LOS NODOS DEL DOCUMENTO EN BUSCA DE LA INFORMACIÓN
        if (navigator.SelectSingleNode("conexion/datasource") != null)
        {   // dataSource
            node = navigator.SelectSingleNode("conexion/datasource");
            dataSource = node.InnerXml.ToString();
        }
        if (navigator.SelectSingleNode("conexion/initialcatalog") != null)
        {   // initialCatalog
            node = navigator.SelectSingleNode("conexion/initialcatalog");
            initialCatalog = node.InnerXml.ToString();
        }
        if (navigator.SelectSingleNode("conexion/userid") != null)
        {   // userId
            node = navigator.SelectSingleNode("conexion/userid");
            userId = node.InnerXml.ToString();
        }
        if (navigator.SelectSingleNode("conexion/password") != null)
        {   // password
            node = navigator.SelectSingleNode("conexion/password");
            password = node.InnerXml.ToString();
        }
                
        // Definimos la cadena con la que conectaremos a la Base de Datos de Triada, en CIPRES
        conexion.ConnectionString = @"Data Source=" + dataSource + ";Initial Catalog=" + initialCatalog + ";User Id=" + userId + ";Password=" + password;


        // Si hemos rellenado al menos una de las casillas
        if ((sip.Length > 0) || (dni.Length > 0) || (nombre.Length > 0) || (apellido1.Length > 0) || (apellido2.Length > 0) || (anyo.Length > 0))
        {
            // Sentencia SELECT inicial
            string SelectSentence = "SELECT * FROM [TRIADA] WHERE (";

            if (sip.Length > 0)        // Si también rellenamos el SIP
            {
                // Búsqueda exacta
                SelectSentence += "([USUARIO] = '" + sip + "') AND ";
            }
            if (dni.Length > 0)        // Si también rellenamos el NIF
            {
                string dni_aux;
                int dni_int;
                if (dni[0] == 'X' || dni[0] == 'x')      // Si es un DNI extranjero
                {
                    dni_aux = dni.Substring(1);     // Quitamos la X para calcular la letra
                    // Convertimos la cadena en un entero para poder aplicarle la fórmula
                    dni_int = Convert.ToInt32(dni_aux);
                }
                else {
                    if (dni[0] == 'Y' || dni[0] == 'y')
                    {
                        dni_aux = "1" + dni.Substring(1);     // Quitamos la X para calcular la letra
                        // Convertimos la cadena en un entero para poder aplicarle la fórmula
                        dni_int = Convert.ToInt32(dni_aux);
                    }
                    else
                    {
                        // Convertimos la cadena en un entero para poder aplicarle la fórmula
                        dni_int = Convert.ToInt32(dni);
                    }
                }
                
                // Llamamos a la función que calcula la letra del NIF
                // a partir de los dígitos del DNI
                string letra = letra_nif((uint)dni_int);

                // Concatenamos los dígitos del DNI con su correspondiente letra del NIF
                string nif = dni + letra;

                // Búsqueda exacta
                SelectSentence += "([NIF] LIKE '" + nif.ToUpper() + "') AND ";
            }
            if (nombre.Length > 0)     // Si también rellenamos el NOMBRE
            {
                // Búsqueda pacial directamente
                SelectSentence += "([NOM] LIKE '%' + '" + nombre.ToUpper() + "' + '%') AND ";
            }
            if (apellido1.Length > 0)  // Si también rellenamos el APELLIDO1
            {
                // Permitimos la búsqueda parcial mediante el operador "LIKE"
                SelectSentence += "([APE1] LIKE '" + apellido1.ToUpper() + "') AND ";
            }
            if (apellido2.Length > 0)  // Si también rellenamos el APELLIDO1
            {
                // Permitimos la búsqueda parcial mediante el operador "LIKE"
                SelectSentence += "([APE2] LIKE '" + apellido2.ToUpper() + "') AND ";
            }

            
            
            if (anyo.Length > 0){  // Si también rellenamos el AÑO
                
                string diaMax = "31";
                int anyoInt = Int32.Parse(anyo);
                
                if (mes.Length > 0)
                {  // Si también rellenamos el MES
                    if (dia.Length > 0)
                    {  // Si también rellenamos el DÍA
                        SelectSentence += "([FechaNacimiento] = '" + anyo + "-" + dia + "-" + mes + " 00:00') AND ";
                    }
                    else
                    {  // Si no rellenamos el DÍA
                        SelectSentence += "([FechaNacimiento] >= '" + anyo + "-01-" + mes + " 00:00') AND ";
                        if (mes == "02" || mes == "2")
                        {
                            if (anyoInt % 100 == 0)
                            {
                                diaMax = "28";
                            }
                            else
                            {
                                if (anyoInt % 4 == 0)
                                {
                                    diaMax = "29";
                                }
                                else
                                {
                                    diaMax = "28";
                                }
                            }
                        }
                        if (mes == "04" || mes == "4" || mes == "06" || mes == "6" || mes == "09" || mes == "9" || mes == "11")
                        {
                            diaMax = "30";
                        }
                        SelectSentence += "([FechaNacimiento] <= '" + anyo + "-" + diaMax + "-" + mes + " 00:00') AND ";
                    }
                }
                else
                {  // Si no rellenamos el MES
                    SelectSentence += "([FechaNacimiento] >= '" + anyo + "-01-01 00:00') AND ";
                    SelectSentence += "([FechaNacimiento] <= '" + anyo + "-31-12 00:00') AND ";
                }
            }

            // Para quitar el último " AND" de la sentencia SELECT
            SelectSentence = SelectSentence.Remove(SelectSentence.Length - 5);
            SelectSentence += ")";       // Cerramos la sentencia SELECT
            
            ///// Guardamos en 'Log.txt' la consulta
            // Especificamos la ruta de 'Log.txt'
            const string fic = @"C:\Inetpub\wwwroot\PruebasSip\Logs\BuscaTriadaWS_Log.txt";
            // Creamos la cadena a escribir
            string texto = string.Empty;

            texto = "[" + DateTime.Now.ToString() + "]";
            texto += " IP request: " + ip;
            texto += " User: " + usuario;
            texto += " -> " + SelectSentence;

            // Añadimos a 'Log.txt' la nueva cadena
            System.IO.StreamWriter sw = new System.IO.StreamWriter(fic, true, System.Text.Encoding.Default);
            sw.WriteLine(texto.ToUpper());
            sw.Close();
            
            // Conectamos con la Base de Datos enviando la sentencia SELECT y la cadena de conexión
            SqlDataAdapter adaptador = new SqlDataAdapter(SelectSentence, conexion);
            // Rellenamos el DataSet con cada coincidencia
            adaptador.Fill(MiDataSet, "persona");
            conexion.Close();
            if (MiDataSet.GetXml().Length == 13)
            {
                // Si no obtenemos ninguna coincidencia en TRIADA
                respuesta = "<respuesta>NO SE HA ENCONTRADO NINGUNA COINCIDENCIA.</respuesta>";

                // Convertimos la cadena en un XPathDocment
                StringReader rdr = new StringReader(respuesta);
                XPathDocument resp_xpath = new XPathDocument(rdr);

                // Mostramos el documento XML
                return resp_xpath.CreateNavigator().InnerXml;
                
            }
            else
            {
                // Volcamos el resultado del DataSet en un documento XML
                respuesta = MiDataSet.GetXml().ToString();

                // Convertimos la cadena recibida en un XPathDocment para poder recorrerlo
                StringReader rdr = new StringReader(respuesta);
                XPathDocument resp_xpath = new XPathDocument(rdr);

                // Mostramos el documento XML
                return resp_xpath.CreateNavigator().InnerXml;

            }
        }
        else
        {
            // Si no se rellena ningún campo de búsqueda
            respuesta = "<respuesta>DEBE ESPECIFICAR ALGÚN CRITERIO DE BÚSQUEDA.</respuesta>";

            // Convertimos la cadena en un XPathDocment
            StringReader rdr = new StringReader(respuesta);
            XPathDocument resp_xpath = new XPathDocument(rdr);

            // Mostramos el documento XML
            return resp_xpath.CreateNavigator().InnerXml;
        }
    }
}