﻿using System;
using System.Configuration;
using System.Data;
using System.Data.Sql;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using SIP;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Net;
using System.IO;
using System.Xml;
using System.Xml.XPath;
using System.Security.Principal;
using System.DirectoryServices;
using System.Collections.Specialized;


public partial class _Default : System.Web.UI.Page 
{


    public bool IsAuthenticated(string srvr, string usr, string pwd)
    {
        //srvr = ldap server, e.g. LDAP://domain.com
        //usr = user name
        //pwd = user password
        bool authenticated = false;

        try
        {
            DirectoryEntry entry = new DirectoryEntry(srvr, usr, pwd);
            object nativeObject = entry.NativeObject;
            authenticated = true;
        }
        catch (DirectoryServicesCOMException cex)
        {
            //not authenticated; reason why is in cex
        }
        catch (Exception ex)
        {
            //not authenticated due to some other exception [this is optional]
        }
        return authenticated;
    }



    protected void Page_Load(object sender, EventArgs e)
    // Al cargar la página
    {
        // Damos título a la página
        this.Title = "Búsqueda en TRIADA";


        // Obtenemos la dirección IP de la consulta al servicio web
        string ip = this.Context.Request.UserHostAddress;

        // Recuperamos el login y el password
        if (!IsPostBack)
        {
            lblUser.Text = Context.Items["user"].ToString();
            lblPass.Text = Context.Items["pass"].ToString();
        }

        // Variables para la conexión al Active Directory
        string dominio = @"LDAP://baladre";
        string user = lblUser.Text;
        string pass = lblPass.Text;

        /////// Compruebo en el Active Directory si el usuario está autorizado a utilizar la aplicación
        try
        {
            if (IsAuthenticated(@"LDAP://baladre", user, pass) == true)
            {
                /////// Solicitamos al Active Directory información del usuario logueado
                AuthenticationTypes at = AuthenticationTypes.Anonymous;
                at = AuthenticationTypes.Secure;

                DirectoryEntry entryRoot = new DirectoryEntry(@"LDAP://baladre", user, pass, at);

                DirectorySearcher ds = new DirectorySearcher(entryRoot);

                ds.Filter = "samaccountname=" + user;

                /////// Obtengo del Active Directory los grupos a los que pertenece el usuario logueado
                ds.PropertiesToLoad.Add("memberof");

                SearchResult sr = ds.FindOne();

                System.Text.StringBuilder sb = new System.Text.StringBuilder();

                bool BuscaTriada = false;

                foreach (string var in sr.Properties.PropertyNames)
                {
                    for (int i = 0; i < sr.Properties[var].Count; i++)
                        if (sr.Properties[var][i].ToString().Contains("CN=BuscaTriada"))
                        {
                            BuscaTriada = true;
                        }
                }

                if (BuscaTriada == false)
                {
                    ///// Guardamos en 'BuscaTriada_Log.txt' la consulta
                    // Especificamos la ruta de 'BuscaTriada_Log.txt'
                    const string fic = @"C:\Inetpub\wwwroot\PruebasSip\Logs\BuscaTriada_Log.txt";
                    // Creamos la cadena a escribir
                    string texto = string.Empty;

                    texto = "[" + DateTime.Now.ToString() + "]";
                    texto += " >>> NO PERTENECE AL GRUPO 'BUSCATRIADA' <<<";
                    texto += " IP request: " + ip;
                    texto += " User: " + user;
                    texto.ToUpper();
                    // Añadimos a 'BuscaTriada_Log.txt' la nueva cadena
                    System.IO.StreamWriter sw = new System.IO.StreamWriter(fic, true, System.Text.Encoding.Default);
                    sw.WriteLine(texto.ToUpper());
                    sw.Close();
                    Response.Redirect("~/Denied.aspx");
                    return;
                }

                /////// Obtengo del Active Directory el nombre del usuario logueado
                ds.PropertiesToLoad.Remove("memberof");
                ds.PropertiesToLoad.Add("displayname");

                sr = ds.FindOne();

                sb = new System.Text.StringBuilder();

                foreach (string var in sr.Properties.PropertyNames)
                {
                    for (int i = 0; i < sr.Properties[var].Count; i++)
                    {
                        lblLogueado.Text = sr.Properties[var][i].ToString();
                    }
                }
            }
            else
            {
                ///// Guardamos en 'BuscaTriada_Log.txt' la consulta
                // Especificamos la ruta de 'BuscaTriada_Log.txt'
                const string fic = @"C:\Inetpub\wwwroot\PruebasSip\Logs\BuscaTriada_Log.txt";
                // Creamos la cadena a escribir
                string texto = string.Empty;

                texto = "[" + DateTime.Now.ToString() + "]";
                texto += " >>> NO AUTENTIFICADO <<<";
                texto += " IP request: " + ip;
                texto += " User: " + user;
                texto.ToUpper();
                // Añadimos a 'BuscaTriada_Log.txt' la nueva cadena
                System.IO.StreamWriter sw = new System.IO.StreamWriter(fic, true, System.Text.Encoding.Default);
                sw.WriteLine(texto.ToUpper());
                sw.Close();
                Response.Redirect("~/Denied.aspx");
                return;
            }
        }
        catch (Exception ex)     // Si devuelve algún error
        {
            Response.Redirect("~/Denied.aspx");
            return;
        }

        
        /////////


        string respuesta = string.Empty;
  
        /////////

        // Ponemos el foco en la primera casilla
        SetFocus(txtSip);
    }
    
    protected void GridView1_Sorting(object sender, GridViewSortEventArgs e)
    // Al hacer click sobre el título de la columna por la cual queremos ordenar
    {
        // Indicamos la expresión por la que se ordenará el GridView
        // y la almacenamos en 'lblExprOrd'
        this.lblExprOrd.Text = e.SortExpression.ToString();
        // Variable dummy
        EventArgs e2 = new EventArgs();
        // Llamamos a la función para mostrar el GridView
        Order_And_Page(this, e2);
    }

    protected void Button1_Click(object sender, EventArgs e)
    // Al hacer click en el botón
    {

        string user = lblUser.Text;
        string pass = lblPass.Text;

        lblExprOrd.Text = "Numero SIP";
        lblPagInd.Text = "0";
        
        // Vaciamos 'lblAviso'
        lblAviso.Text = "";
        // Vaciamos 'lblCuenta'
        lblCuenta.Text = "";

        // Si no se ha rellenado ninguna de las casillas
        if ((txtSip.Text.Length == 0) && (txtNif.Text.Length == 0) && (txtNombre.Text.Length == 0) && (txtApellido1.Text.Length == 0) && (txtApellido2.Text.Length == 0) && (txtAnyo.Text.Length == 0))
        {
            // Avisamos al usuario de que no se puede efectuar la búsqueda
            lblAviso.Text = "Ningún criterio de búsqueda ha sido especificado.";
            // Salimos
            return;
        }

        if (txtDia.Text.Length > 0)  // Si rellenamos el DÍA
        {
            if (txtMes.Text.Length == 0 || txtAnyo.Text.Length == 0)  // Pero no rellenamos el MES y el AÑO
            {
                txtDia.Text = "";  // No hacemos caso del DÍA
            }
        }
        if (txtMes.Text.Length > 0)  // Si rellenamos el MES
        {
            if (txtAnyo.Text.Length == 0)  // Pero no rellenamos el AÑO
            {
                txtMes.Text = "";  // No hacemos caso del MES
            }
        }

        if (txtAnyo.Text.Length > 0)
        {  // Si rellenamos el AÑO
            int anyoInt = Int32.Parse(txtAnyo.Text);
            if (txtMes.Text.Length > 0)
            {  // Si también rellenamos el MES
                int mesInt = Int32.Parse(txtMes.Text);
                if (mesInt < 1 || mesInt > 12)
                {  // Si indicamos un MES que no existe
                    // Avisamos al usuario de que no se puede efectuar la búsqueda
                    lblAviso.Text = "Fecha incorrecta.";
                    // Salimos
                    return;
                }
                if (txtDia.Text.Length > 0)
                {  // Si también rellenamos el DÍA
                    int diaInt = Int32.Parse(txtDia.Text);
                    if (diaInt < 1 || diaInt > 31)
                    {  // Para cualquier MES, si indicamos un DÍA que no existe
                        // Avisamos al usuario de que no se puede efectuar la búsqueda
                        lblAviso.Text = "Fecha incorrecta.";
                        // Salimos
                        return;
                    }
                    if (mesInt == 4 || mesInt == 6 || mesInt == 9 || mesInt == 11)
                    {  // Si es Abril, Junio, Septiembre o Noviembre
                        if (diaInt > 30)
                        {  // Si indicamos un DÍA que no existe
                            // Avisamos al usuario de que no se puede efectuar la búsqueda
                            lblAviso.Text = "Fecha incorrecta.";
                            // Salimos
                            return;
                        }
                    }
                  if (mesInt == 2) {  // Si es Febrero
                        int diaMax = 28;
                        if (anyoInt % 100 == 0)
                        {
                            diaMax = 28;
                        }
                        else
                        {
                            if (anyoInt % 4 == 0)
                            {
                                diaMax = 29;
                            }
                            else
                            {
                                diaMax = 28;
                            }
                        }
                        if (diaInt > diaMax){
                            // Avisamos al usuario de que no se puede efectuar la búsqueda
                            lblAviso.Text = "Fecha incorrecta.";
                            // Salimos
                            return;
                        }
                    }
                }
            }
        }

        ///// Guardamos en 'BuscaTriada_Log.txt' la consulta
        // Especificamos la ruta de 'BuscaTriada_Log.txt'
        const string fic = @"C:\Inetpub\wwwroot\PruebasSip\Logs\BuscaTriada_Log.txt";
        // Obtenemos la dirección IP del cliente
        string ip = HttpContext.Current.Request.UserHostAddress.ToString();
        // Creamos la cadena a escribir
        string texto = string.Empty;

        texto = "[" + DateTime.Now.ToString() + "]";
        texto += " IP request: " + ip;
        texto += " User: " + user;
        texto += " -> " + " SIP=" + txtSip.Text;
        texto += " NIF=" + txtNif.Text;
        texto += " NOM=" + txtNombre.Text;
        texto += " APE1=" + txtApellido1.Text;
        texto += " APE2=" + txtApellido2.Text;
        texto += " DIA=" + txtDia.Text;
        texto += " MES=" + txtMes.Text;
        texto += " ANYO=" + txtAnyo.Text;
        texto.ToUpper();
        // Añadimos a 'BuscaTriada_Log.txt' la nueva cadena
        System.IO.StreamWriter sw = new System.IO.StreamWriter(fic, true, System.Text.Encoding.Default);
        sw.WriteLine(texto.ToUpper());
        sw.Close();

        // Llamamos al Servicio Web
        dtvceres.BuscaTRIADAwebservice wsBuscaTriada = new dtvceres.BuscaTRIADAwebservice();
        try     // Si no devuelve ningún error
        {
            string resp = wsBuscaTriada.busca_TRIADA(txtSip.Text, txtNif.Text, txtNombre.Text, txtApellido1.Text, txtApellido2.Text, txtDia.Text, txtMes.Text, txtAnyo.Text, lblUser.Text, lblPass.Text);

            txtResp.Text = resp;
        }
        catch (Exception ex)     // Si devuelve algún error
        {
            // Mostramos el aviso de error en lblAviso
            lblAviso.Text = "Fallo en la conexión. Esto puede deberse a que usted no esté autorizado a consultar esta base de datos.";

            // Terminamos la ejecución
            return;
        }


        EventArgs e2 = new EventArgs();
        // Doble llamada a la función que muestra el GridView
        Order_And_Page(this, e2);
        Order_And_Page(this, e2);

        /**********************************************/
        /* Es necesario llamar dos veces a la función */
        /**********************************************/
    }

    protected void Order_And_Page(object sender, EventArgs e)
    // Función usada para reordenar la tabla y/o cambiar de página
    {
        // Creamos una cadena con el contenido del 'txtResp' que nos sirve de "almacén"
        string resp = txtResp.Text;

        if (resp == "<respuesta>USTED NO TIENE PERMISO PARA CONSULTAR ESTA BASE DE DATOS.</respuesta>"){
            lblAviso.Text = "USTED NO TIENE PERMISO PARA CONSULTAR ESTA BASE DE DATOS.";
            return;
        }

        // Convertimos la cadena recibida en un XPathDocument para poder recorrerlo
        StringReader rdr = new StringReader(resp);
        XPathDocument resp_xpath = new XPathDocument(rdr);

        // Creamos el navegador que nos permitirá recorrer los nodos
        XPathNavigator navigator = resp_xpath.CreateNavigator();

        // Creamos una tabla y una fila
        DataTable tabla = new DataTable();
        DataRow fila;
        
        // Creamos variables para todos los datos que obtenemos del SIP
        Int32 item_sip = new Int32();
        string item_nombre = string.Empty;
        string item_apellido1 = string.Empty;
        string item_apellido2 = string.Empty;
        string item_nif = string.Empty;
        string item_fechanac = string.Empty;
        string item_numss = string.Empty;
        DateTime item_fechanac_date = new DateTime();

        // Para cada columna de la fila especificamos su tipo y agregamos el título
        tabla.Columns.Add("Numero SIP", item_sip.GetType());
        tabla.Columns.Add("Nombre");
        tabla.Columns.Add("Apellido 1");
        tabla.Columns.Add("Apellido 2");
        tabla.Columns.Add("NIF");
        tabla.Columns.Add("Fecha de Nacimiento", item_fechanac_date.GetType());
        tabla.Columns.Add("Numero SS");

        // Variable contador de coincidencias
        int cuenta = 0;

        // Para cada coincidencia en la base de datos TRIADA
        foreach (XPathNavigator i in navigator.Select("respuesta/persona"))
        {
            // Vaciamos las variables
            item_sip = 0;
            item_nombre = string.Empty;
            item_apellido1 = string.Empty;
            item_apellido2 = string.Empty;
            item_nif = string.Empty;
            item_numss = string.Empty;
            item_fechanac_date = new DateTime();

            // Si se encuentra la etiqueta "USUARIO"
            if (i.SelectSingleNode("USUARIO") != null)
            {
                // Guardamos el contenido en su variable
                item_sip = Int32.Parse(i.SelectSingleNode("USUARIO").InnerXml.ToString());
            }
            // Si se encuentra la etiqueta "NOM"
            if (i.SelectSingleNode("NOM") != null)
            {
                // Guardamos el contenido en su variable
                item_nombre = i.SelectSingleNode("NOM").InnerXml.ToString();
            }
            // Si se encuentra la etiqueta "APE1"
            if (i.SelectSingleNode("APE1") != null)
            {
                // Guardamos el contenido en su variable
                item_apellido1 = i.SelectSingleNode("APE1").InnerXml.ToString();
            }
            // Si se encuentra la etiqueta "APE2"
            if (i.SelectSingleNode("APE2") != null)
            {
                // Guardamos el contenido en su variable
                item_apellido2 = i.SelectSingleNode("APE2").InnerXml.ToString();
            }
            // Si se encuentra la etiqueta "FechaNacimiento"
            if (i.SelectSingleNode("FechaNacimiento") != null)
            {
                // Guardamos el contenido en su variable
                item_fechanac_date = DateTime.Parse(i.SelectSingleNode("FechaNacimiento").InnerXml.ToString());
            }
            // Si se encuentra la etiqueta "NIF"
            if (i.SelectSingleNode("NIF") != null)
            {
                // Guardamos el contenido en su variable
                item_nif = i.SelectSingleNode("NIF").InnerXml.ToString();
            }
            // Si se encuentra la etiqueta "NumSS"
            if (i.SelectSingleNode("NumSS") != null)
            {
                // Guardamos el contenido en su variable
                item_numss = i.SelectSingleNode("NumSS").InnerXml.ToString();
            }

            // Creamos una nueva fila para insertar en la tabla
            fila = tabla.NewRow();
            // Rellenamos cada columna de la fila con su valor correspondiente
            fila["Numero SIP"] = item_sip;
            fila["Nombre"] = item_nombre;
            fila["Apellido 1"] = item_apellido1;
            fila["Apellido 2"] = item_apellido2;
            fila["NIF"] = item_nif;
            fila["Fecha de Nacimiento"] = item_fechanac_date;
            fila["Numero SS"] = item_numss;

            // Añadimos la nueva fila a la tabla
            tabla.Rows.Add(fila);

            // Se ha encontrado otra coincidencia
            cuenta++;
        }

        // Mostramos en una etiqueta un mensaje con el número de coincidencias encontradas
        if (cuenta == 1)
        {
            lblCuenta.Text = "Se ha encontrado 1 coincidencia.";
        }
        else
        {
            lblCuenta.Text = "Se han encontrado " + cuenta + " coincidencias.";
        }

        // Creamos un DataView con el contenido de la tabla
        DataView dv = new DataView(tabla);
        // Ordenamos por la nueva expresión
        dv.Sort = this.lblExprOrd.Text;

        // Creamos un documento XML con el contenido de 'resp'
        XmlDocument xml_doc = new XmlDocument();
        xml_doc.LoadXml(resp);

        // Volcamos el contenido del DataView al GridView
        grdResultado.DataSource = dv;
        grdResultado.DataBind();
        // Permitimos paginación
        grdResultado.AllowPaging = true;
        // Mostramos la página que se ha seleccionado
        grdResultado.PageIndex = Int32.Parse(this.lblPagInd.Text);
        
    }

    protected void GridView1_SelectedIndexChanging1(object sender, GridViewSelectEventArgs e)
    // Al pulsar sobre el icono de la Tarjeta SIP
    {
        string user = lblUser.Text;
        string pass = lblPass.Text;

        /////////

        // Obtenemos la dirección IP de la consulta al servicio web
        string ip2 = this.Context.Request.UserHostAddress;

 
        // Almacenamos en una variable el Número de SIP
        string sip = grdResultado.Rows[e.NewSelectedIndex].Cells[1].Text;

        ///// Guardamos en 'BuscaTriada_Log.txt' la consulta
        // Especificamos la ruta de 'BuscaTriada_Log.txt'
        const string fic = @"C:\Inetpub\wwwroot\PruebasSip\Logs\BuscaTriada_Log.txt";
        // Obtenemos la dirección IP del cliente
        string ip = HttpContext.Current.Request.UserHostAddress.ToString();
        // Creamos la cadena a escribir
        string texto = string.Empty;

        texto = "[" + DateTime.Now.ToString() + "]";
        texto += " IP request: " + ip;
        texto += " User: " + user;
        texto += " -> " + "SIP=" + sip;
        // Añadimos a 'BuscaTriada_Log.txt' la nueva cadena
        System.IO.StreamWriter sw = new System.IO.StreamWriter(fic, true, System.Text.Encoding.Default);
        sw.WriteLine(texto.ToUpper());
        sw.Close();
        
        // Llamamos al Servicio Web
        dtvceres.BuscaSIPwebservice wsBuscaSIP = new dtvceres.BuscaSIPwebservice();
        
        // Creamos una variable para almacenar la respuesta del SIP
        string respuesta = string.Empty;

        // Preguntamos a la Base de Datos del SIP por ése Número de SIP en concreto
        try
        {
            // Llamamos a la función 'busca_SIP' del servicio web pasándole el número de SIP
            // y el usuario que realiza la consulta
            respuesta = wsBuscaSIP.busca_SIP(sip, user, pass);

            if (respuesta == "<respuesta>USTED NO TIENE PERMISO PARA CONSULTAR ESTA BASE DE DATOS.</respuesta>")
            {
                lblAviso.Text = "USTED NO TIENE PERMISO PARA CONSULTAR ESTA BASE DE DATOS.";
                lblCuenta.Text = "";
                return;
            }
        }
        catch   // Si hay error
        {
            // Avisamos al usuario de que ha habido un error
            respuesta = "Error en la conexión. Inténtelo de nuevo más tarde.";
            lblAviso.Text = respuesta;
            lblCuenta.Text = string.Empty;
            return;
        }

        // Convertimos la cadena recibida en un XPathDocument para poder recorrerlo
        StringReader rdr = new StringReader(respuesta);
        XPathDocument resp_xpath = new XPathDocument(rdr);

        // Dejamos de mostrar el GridView
        grdResultado.Visible = false;

        // Almacenamos en el contexto tanto la cadena como el Xpath
        Context.Items.Add("resp", resp_xpath);
        Context.Items.Add("cadenaxml", respuesta);

        // Llamamos a la página donde se muestra el resultado formateado
	    Server.Transfer("Resultado.aspx", false);  
    }

    protected void grdResultado_PageIndexChanging(object sender, GridViewPageEventArgs e)
    // Al hacer click sobre el número de página que queremos que nos muestre
    {
        // Indicamos qué página del GridView queremos ver
        // y la almacenamos en 'lblPagInd'
        this.lblPagInd.Text = ((int) e.NewPageIndex).ToString();
        // Variable dummy
        EventArgs e2 = new EventArgs();
        // Doble llamada a la función que muestra el GridView
        Order_And_Page(this, e2);
        Order_And_Page(this, e2);
        
        /**********************************************/
        /* Es necesario llamar dos veces a la función */
        /**********************************************/
    }
}
