﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Xml;
using System.Xml.XPath;

public partial class Resultado : System.Web.UI.Page
{

    protected void Page_Load(object sender, EventArgs e)
    // Al cargar la página
    {
        if (!IsPostBack)
        {
            ////// ADQUISICIÓN DE DATOS DEL DOCUMENTO XML
            // Recuperamos el documento del contexto
            XPathDocument document = (XPathDocument)Context.Items["resp"];
            // Creamos el navegador que nos permitirá recorrer los nodos
            XPathNavigator navigator = document.CreateNavigator();
            
            // Creamos una cadena con todo el documento XML
            string respuesta = document.CreateNavigator().InnerXml;
            // y lo mostramos en un TextBox (ahora oculto)
            txtCodigoXML.Text = respuesta;
            // Creamos la variable que recorrerá los nodos en busca de información
            XPathNavigator node;

            ////// DECLARACIÓN DE VARIABLES DE LOS DATOS QUE FORMATEAREMOS
            // Datos Personales
            string apellido1 = string.Empty;    // Apellido 1
            string apellido2 = string.Empty;    // Apellido 2
            string nombre = string.Empty;       // Nombre
            string nif = string.Empty;          // NIF
            string sexo = string.Empty;         // Sexo
            string sip = string.Empty;          // Número SIP
            string cip = string.Empty;          // Código CIP
            string ss = string.Empty;           // Número Seguridad Social
            // Datos del Nacimiento
            string fechanac = string.Empty;     // Fecha de Nacimiento
            string loca_nac = string.Empty;     // Localidad de Nacimiento
            string prov_nac = string.Empty;     // Provincia de Nacimiento
            string pais_nac = string.Empty;     // Pais de Nacimiento
            // Datos de la Residencia
            string tipo_via = string.Empty;     // Tipo de Vía
            string nombre_via = string.Empty;   // Nombre de la Vía
            string domicilio = string.Empty;    // Domicilio (Patio - Piso - Puerta)
            string cod_postal = string.Empty;   // Código Postal
            string telefono = string.Empty;     // Teléfono(s)
            string localidad = string.Empty;    // Localidad
            string provincia = string.Empty;    // Provincia
            // Datos Médicos
            string clmed = string.Empty;        // Clave Médica
            string hospital = string.Empty;     // Hospital Asignado
            string centro = string.Empty;       // Centro Médico Asignado
            string medico = string.Empty;       // Médico de Cabecera
            string especialidad = string.Empty; // Especialidad del Médico de Cabecera
            // Última Actualización
            string actualizacion = string.Empty;    // Fecha de la última
                                                    // actualización en la 
                                                    // base de datos del SIP

            ////// RECORREMOS LOS NODOS DEL DOCUMENTO EN BUSCA DE LA INFORMACIÓN
            // Datos personales
            if (navigator.SelectSingleNode("msg_respuesta/usu/iden/ape1") != null)
            {   // Apellido 1
                node = navigator.SelectSingleNode("msg_respuesta/usu/iden/ape1");
                apellido1 += node.InnerXml.ToString();
            }

            if (navigator.SelectSingleNode("msg_respuesta/usu/iden/ape2") != null)
            {   // Apellido 2
                node = navigator.SelectSingleNode("msg_respuesta/usu/iden/ape2");
                apellido2 += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/iden/nomb") != null)
            {   // Nombre
                node = navigator.SelectSingleNode("msg_respuesta/usu/iden/nomb");
                nombre += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/iden/nif") != null)
            {   // NIF
                node = navigator.SelectSingleNode("msg_respuesta/usu/iden/nif");
                nif += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/iden/sexo") != null)
            {   // Sexo
                node = navigator.SelectSingleNode("msg_respuesta/usu/iden/sexo");
                sexo += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/iden/nsip") != null)
            {   // Número SIP
                node = navigator.SelectSingleNode("msg_respuesta/usu/iden/nsip");
                sip += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/iden/cip") != null)
            {   // Código CIP
                node = navigator.SelectSingleNode("msg_respuesta/usu/iden/cip");
                cip += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/acre/nuss") != null)
            {   // Número Seguridad Social
                node = navigator.SelectSingleNode("msg_respuesta/usu/acre/nuss");
                ss += node.InnerXml.ToString();
            }
            // Datos del Nacimiento
            if (navigator.SelectSingleNode("msg_respuesta/usu/iden/fena") != null)
            {   // Fecha de Nacimiento
                node = navigator.SelectSingleNode("msg_respuesta/usu/iden/fena");
                fechanac += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/iden/lona/nomb") != null)
            {   // Localidad de Nacimiento
                node = navigator.SelectSingleNode("msg_respuesta/usu/iden/lona/nomb");
                loca_nac += node.InnerXml.ToString() + " ";
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/iden/prna/nomb") != null)
            {   // Provincia de Nacimiento
                node = navigator.SelectSingleNode("msg_respuesta/usu/iden/prna/nomb");
                prov_nac += "(" + node.InnerXml.ToString() + ") - ";
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/iden/pana/nomb") != null)
            {   // Pais de Nacimiento
                node = navigator.SelectSingleNode("msg_respuesta/usu/iden/pana/nomb");
                pais_nac += node.InnerXml.ToString();
            }
            // Datos de la Residencia
            if (navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/cal/calcod/tiv") != null)
            {   // Tipo de Vía
                node = navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/cal/calcod/tiv");
                tipo_via += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/cal/calcod/nomb") != null)
            {   // Nombre de Vía
                node = navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/cal/calcod/nomb");
                nombre_via += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/espe/nume") != null)
            {   // Patio
                node = navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/espe/nume");
                domicilio += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/espe/piso") != null)
            {   // Piso
                node = navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/espe/piso");
                domicilio += " - " + node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/espe/prta") != null)
            {   // Puerta
                node = navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/espe/prta");
                domicilio += " - " + node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/copo") != null)
            {   // Código Postal
                node = navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/copo");
                cod_postal += node.InnerXml.ToString();
            }
            foreach (XPathNavigator i in navigator.Select("msg_respuesta/usu/loca/tele"))
            {  // Teléfono(s)
                telefono += i.InnerXml.ToString() + "<br/>";
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/loc/loc_nomb") != null)
            {   // Localidad
                node = navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/loc/loc_nomb");
                localidad += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/prv/nomb") != null)
            {   // Provincia
                node = navigator.SelectSingleNode("msg_respuesta/usu/loca/dirRes/prv/nomb");
                provincia += node.InnerXml.ToString();
            }
            // Datos Médicos
            if (navigator.SelectSingleNode("msg_respuesta/usu/asig/clm") != null)
            {   // Clave Médica
                node = navigator.SelectSingleNode("msg_respuesta/usu/asig/clm");
                clmed += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/asig/hos/nomb") != null)
            {   // Hospital Asignado
                node = navigator.SelectSingleNode("msg_respuesta/usu/asig/hos/nomb");
                hospital += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/asig/cen/nomb") != null)
            {   // Centro Médico Asignado
                node = navigator.SelectSingleNode("msg_respuesta/usu/asig/cen/nomb");
                centro += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/asig/pro/noap") != null)
            {   // Médico de Cabecera
                node = navigator.SelectSingleNode("msg_respuesta/usu/asig/pro/noap");
                medico += node.InnerXml.ToString();
            }
            if (navigator.SelectSingleNode("msg_respuesta/usu/asig/pro/desc") != null)
            {   // Especialidad del Médico de Cabecera
                node = navigator.SelectSingleNode("msg_respuesta/usu/asig/pro/desc");
                especialidad += node.InnerXml.ToString();
            }
            // Última Actualización
            if (navigator.SelectSingleNode("msg_respuesta/usu/misc/fact") != null)
            {   // Fecha de la Última Actualización de la base de datos del SIP
                node = navigator.SelectSingleNode("msg_respuesta/usu/misc/fact");
                actualizacion += node.InnerXml.ToString();
            }

            // Aprovechamos para dar título a la web con el nombre de la persona
            this.Title = apellido1 + " " + apellido2 + ", " + nombre;

            ////// FORMATO DE LAS ETIQUETAS
            // lblApellidosNombrer
            lblApellidosNombrer.Text = apellido1 + " " + apellido2 + ", " + nombre;
            // lblNIFr
            lblNIFr.Text = nif;
            // lblSexor
            if (sexo == "M")
            {   // Si es varón
                lblSexor.Text = "    ♀";
            }
            else
            {
                if (sexo == "H")
                {   // Si es hembra
                    lblSexor.Text = "    ♂";
                }
                else
                {   // Si no se especifica
                    lblSexor.Text = "";
                }
            }
            // lblSIPr
            lblSIPr.Text = sip;
            // lblCIPr
            lblCIPr.Text = cip;
            // lblSSr
            lblSSr.Text = ss;
            // lblFechaNacr
            lblFechaNacr.Text = formatea_fecha(fechanac).ToUpper();
            // lblLugarNacr
            lblLugarNacr.Text = loca_nac + prov_nac + pais_nac;
            //lblDomicilior
            lblDomicilior.Text = tipo_via + " " + nombre_via + ", " + domicilio;
            //lblCodPostalr
            lblCPProvr.Text = cod_postal + " - " + localidad + " (" + provincia + ")";
            // lblTelefonor
            lblTelefonor.Text = telefono;
            // lblClavMedr
            lblClavMedr.Text = clmed;
            // lblHospitalr
            lblHospitalr.Text = hospital;
            // lblCentror
            lblCentror.Text = centro;
            // lblMedicor
            lblMedicor.Text = medico;
            // lblEspecialidadr
            lblEspecialidadr.Text = especialidad;
            // lblActr
            lblActr.Text = formatea_fecha(actualizacion);

            // Especificamos la visibilidad inicial de 'txtCodigoXML'
            txtCodigoXML.Visible = false;
        }
    }
    
    protected void ImageButton1_Click(object sender, ImageClickEventArgs e)
    // Al hacer click sobre el botón 'Código XML'
    {
        ////// MOSTRAMOS/OCULTAMOS EL CÓDIGO XML AL PULSAR EL BOTÓN
        // Alternamos la visibilidad del TextBox que contiene el Código XML
        txtCodigoXML.Visible = !txtCodigoXML.Visible;

        // Aprovechamos para dar título a la web con el nombre de la persona
        this.Title = this.lblApellidosNombrer.Text;
        // Ponemos el foco en el TextBox (si está visible)
        SetFocus(txtCodigoXML);
    }

    protected string formatea_fecha(string fecha_orig)
    // Formatea fechas en mayúsculas
    {
        // Extraemos el año de la cadena recibida
        string ano = fecha_orig.Substring(0, 4);
        // Extraemos el mes de la cadena recibida
        string mes = fecha_orig.Substring(5, 2);
        // Extraemos el día de la cadena recibida
        string dia = fecha_orig.Substring(8, 2);
        // Creamos dos variables vacías
        string mes_letra = string.Empty;
        string dia_format = string.Empty;

        // Según qué número de mes sea
        switch (mes)
        {
            case "01":
                mes_letra = "Enero";
                break;
            case "02":
                mes_letra = "Febrero";
                break;
            case "03":
                mes_letra = "Marzo";
                break;
            case "04":
                mes_letra = "Abril";
                break;
            case "05":
                mes_letra = "Mayo";
                break;
            case "06":
                mes_letra = "Junio";
                break;
            case "07":
                mes_letra = "Julio";
                break;
            case "08":
                mes_letra = "Agosto";
                break;
            case "09":
                mes_letra = "Septiembre";
                break;
            case "10":
                mes_letra = "Octubre";
                break;
            case "11":
                mes_letra = "Noviembre";
                break;
            case "12":
                mes_letra = "Diciembre";
                break;
        }

        // Si el día empieza por 0, mostramos sólo el segundo dígito
        if (dia[0] == '0')
        {
            dia_format = dia[1].ToString(); // Lo volcamos a la nueva cadena
        }
        else // Si no lo dejamos tal cual
        {
            dia_format = dia; // Lo volcamos a la nueva cadena
        }

        // Creamos la cadena formateada con los datos correspondientes
        string fecha_dest = dia_format + " de " + mes_letra + " de " + ano;

        // Devolvemos la cadena creada
        return fecha_dest;
    }
}
